<?php
/**
* phpPhotoEditor LIGHT
*
*    Dieses Script ist veroeffentlicht unter der GNU General Public License.
*    This Script is distributed under the GNU General Public License!
*
* @author       Werner Radisch <hausmeister@phpphotoeditor.de>
* @package      phpPhotoEditor LIGHT
* @copyright    2003 by Werner Radisch
* @version      1.0 (2004/08/05)
*/


/*
   foldername, where your editor is located
   e.g 'photoeditor', 'subfolder/editor'
   if it is '' (empty), the script is expected
   in your root directory (not recommended)
   Ordnername, in dem der Editor liegt
   z.B. 'photoeditor', 'unterordner/editor'.
   Ist der Eintrag '' (leer), wird das Skript
   im Hauptverzeichnis erwartet (nicht empfohlen)
*/
$eDir = 'photoeditor_light';

/*
   fixed startfoldername, where your images are located
   e.g 'images', 'subfolder/images', if empty, phpPE tries
   to locate images in all directories phpPE can found
   fester Ordnername, in dem Ihre Bilder liegen,
   z.B. 'bilder', 'unterordner/bilder'.
   ist der wert leer, wird versucht in alle verfgbaren
   ordner bildern zu finden.
*/
//$iDir = '';                         // search all directories from root
                                      // suche startet ab dem hauptverzeichnis
                                      
$iDir = 'photoeditor_light/images';   // start imagesearch from this directory
                                      // bildersuche startet in diesem verzeichnis

/*
   For restricted access to the editor alter $acqSess
   to e.g.:
   $acqSess = 'valid';
   if there is no session called valid, unauthorized user
   will get an errormessage.
   Der Zugriff auf den Editor kann ber eine Session begrenzt
   werden. ndern Sie dazu $acqSess in z.B.:
   $acqSess = 'valid';
   Sollte keine session namens "valid" existieren, erhlt der
   Benutzer keinen Zugriff.
*/
//$acqSess = 'nameOfSessionIndex'; // restricted access
$acqSess = NULL;                   // accessable for everybody

/*
   Set an sessionindex for a language identification. If you do not
   work with different languages, ignore this variable.
   If you work with differnt languages please ensure that there
   is a language.txt.php for each language you offer.
   Legen Sie einen Session-Index fest, der die Informationen ber die
   aktuell verwendete Sprache enthlt. Wenn Sie keine unterschiedlichen
   Sprachen bentigen, knnen Sie diese Variable ignorieren. Andernfalls
   achten Sie darauf, dass fr jede Sprache eine spache.txt.php existiert.
*/
$langSess = 'lang';

/*
   Your default-language. $defLang.txt.php has to be an existing file!
   Standardsprache. Die datei $defLang.txt.php muss existieren!
*/
$defLang = 'de';

/*
   Max width for preview images in filelisting.
   Maximale Breite fr die Bilder in der Bildbersicht.
*/
$pevImgW = 100;

/*
   Images per page in filelisting.
   Anzahl Bilder pro Seite in der Bildbersicht.
*/
$pevImgPP = 6;

/*
   Link/url back to your e.g. main page, e.g:
   $exitLink = 'http://www.yourdomain.com/yourpage.htm';
   $exitLink = 'javascript:self.close()'; //(if we are in a popup window)
   Link/Url zum Verlassen des Editors, z.B.:
   $exitLink = 'http://www.ihredomain.com/ihreseite.htm';
   $exitLink = 'javascript:self.close()'; //(zum Schliessen eines Popups)
*/
$exitLink = 'javascript:self.close();';


/* NO CHANGES BELOW THIS LINE ##################################################
   KEINE NDERUNGEN AB HIER VORNEHMEN ########################################*/

$mainUrl = 'http://'.$_SERVER['HTTP_HOST'].'/'.$eDir;
$mainDir = $_SERVER['DOCUMENT_ROOT'].'/'.$eDir;
$mainWorkDir = $mainDir.'/data';
$workDir = $mainDir.'/data/'.session_id();
$workUrl='./data/';

if(!isset($iDir) || empty($iDir))
{
    $imgDir = $_SERVER['DOCUMENT_ROOT'].'/';
    $imgUrl = 'http://'.$_SERVER['HTTP_HOST'].'/';
}
else
{
    $imgDir = $_SERVER['DOCUMENT_ROOT'].'/'.$iDir.'/';
    $imgUrl = 'http://'.$_SERVER['HTTP_HOST'].'/'.$iDir.'/';
}

$workName = 'workimg';
$indexTpl = './template/overview.html';
$workTpl = './template/editor.html';
$imagelistTpl = './template/imagelist.html';


if(isset($_SESSION[$langSess]))
{ $lang = $_SESSION[$langSess]; }
else
{ $lang = $defLang; }

define('isIncluded', TRUE);


$gifSup = 1;
$pngSup = 1;
$jpegSup = 1;

if(function_exists('imagecreatefromgif'))
{
    $iGif = @imagecreatefromgif($mainDir.'/skin/test.gif');
    if(!$iGif)
    {  $gifSup = 0;  }
    @imagedestroy($iGif);
}
else
{
    $gifSup = 0;
}

if(function_exists('imagecreatefrompng'))
{
    $iPng = @imagecreatefrompng($mainDir.'/skin/test.png');
    if(!$iPng)
    {  $pngSup = 0;  }
    @imagedestroy($iPng);
}
else
{
    $pngSup = 0;
}



if(function_exists('imagecreatefromjpeg'))
{
    $iJpeg = @imagecreatefromjpeg($mainDir.'/skin/test.jpg');
    if(!$iJpeg)
    {  $jpegSup = 0;  }
    @imagedestroy($iJpeg);
}
else
{
    $jpegSup = 0;
}


if(!$gifSup && !$pngSup && !$jpegSup)
{
    die('Fatal error: No GD installed or misconfiguration of GD or script');
}

?>
