<?PHP
/**
* phpPhotoEditor LIGHT
*
*    Dieses Script ist veroeffentlicht unter der GNU General Public License.
*    This Script is distributed under the GNU General Public License!
*
* @author       Werner Radisch <hausmeister@phpphotoeditor.de>
* @package      phpPhotoEditor LIGHT
* @copyright    2003 by Werner Radisch
* @version      1.0 (2004/08/05)
*/

if(!defined('isIncluded'))
{
    die('Access denied');
}
ob_start();
phpinfo();
$gd_info = ob_get_contents();
ob_end_clean();

preg_match('!\nGD Version(.*?)\n!is',strip_tags($gd_info),$regs);
if(isset($regs[1]))
{
    if(strpos($regs[1], "2.")!==false)
        $gdinfo = 2;
    else
        $gdinfo = 1;
}
else
{
    die('no gd');
}

function hexColorToRGB($_hex)
{
    $col['red'] = 100;
    $col['green'] = 100;
    $col['blue'] = 100;
    if(preg_match( "![#]?([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})!i", $_hex, $ret ) )
    {
        $col['red'] = hexdec( $ret[1] );
        $col['green'] = hexdec( $ret[2] );
        $col['blue'] = hexdec( $ret[3] );
    }
    return $col;
}


function getLightness($_r, $_g, $_b)
{
    $kmin = min($_r/255,$_g/255,$_b/255);
    $kmax = max($_r/255,$_g/255,$_b/255);

    return floor(($kmax+$kmin)/2*100);
}


$imgInfo = getimagesize($workDir.'/'.$workName.$_SESSION['img']['type']);
switch($imgInfo[2])
{
    case 1:
        $imgCol01 = imagecreatefromgif($workDir.'/'.$workName.$_SESSION['img']['type']);
        break;
    case 2:
        $imgCol01 = imagecreatefromjpeg($workDir.'/'.$workName.$_SESSION['img']['type']);
        break;
    case 3:
        $imgCol01 = imagecreatefrompng($workDir.'/'.$workName.$_SESSION['img']['type']);
        break;
}



if(!$imgCol01)
{
    die('wrong filetype');
}


if(isset($_POST['action']) && $_POST['action'] == 'grey')
{
    if($gdinfo > 1)
    {
         $imgCol02 = imagecreatetruecolor(imagesx($imgCol01), imagesy($imgCol01));

         for($x=0; $x<imagesx($imgCol01); $x++)
         {
             for($y=0; $y<imagesy($imgCol01); $y++)
             {
                 $i = ImageColorAt($imgCol01, $x, $y);
                 $c = imagecolorsforindex($imgCol01,$i);
                 $avg = round(($c['red'] + $c['green'] +  $c['blue'])/3);
                 $col = imagecolorallocate($imgCol02, $avg, $avg, $avg);
                 imagesetpixel($imgCol02, $x, $y, $col);
             }
         }

         
         switch($imgInfo[2])
         {
                 case 1:
                 case 3:
                    imagepng($imgCol02,$workDir.'/'.$workName.$_SESSION['img']['type']);
                    break;
                 case 2:

                    imagejpeg($imgCol02,$workDir.'/'.$workName.$_SESSION['img']['type'], 100);
                    break;
         }

         
         
         imagedestroy($imgCol02);
    }
    else
    {
        for( $i=0; $i<imagecolorstotal($imgCol01); $i++ )
        {
            $c = ImageColorsForIndex($imgCol01, $i );
            $t = round(($c["red"]+$c["green"]+$c["blue"])/3);
            imagecolorset($imgCol01, $i, $t, $t, $t );
        }
         switch($imgInfo[2])
         {
                 case 1:
                 case 3:
                    imagepng($imgCol01,$workDir.'/'.$workName.$_SESSION['img']['type']);
                    break;
                 case 2:

                    imagejpeg($imgCol01,$workDir.'/'.$workName.$_SESSION['img']['type'], 100);
                    break;
         }
    }
}





if(isset($_POST['action']) && ($_POST['action'] == 'lighter' || $_POST['action'] == 'darker'))
{
    if($_POST['action'] == 'lighter')
        $_func = 2;
    else
        $_func = 1;


    if($gdinfo > 1)
    {
         $imgCol02 = imagecreatetruecolor(imagesx($imgCol01), imagesy($imgCol01));

         for($x=0; $x<imagesx($imgCol01); $x++)
         {
             for($y=0; $y<imagesy($imgCol01); $y++)
             {
                $i = ImageColorAt($imgCol01, $x, $y);
                $col=ImageColorsForIndex($imgCol01,$i);

                    $light = getLightness($col['red'], $col['green'], $col['blue']);
                    $lgt = $light > 0 ? 1/$light :1;
                    $_val = 1.2 + (-0.0061515748 * pow($lgt, 2) + 1.5686515748*$lgt);

                    if($_func == 1)
                    {
                        $red_set=ceil($col['red']/$_val) < 0 ? 0 : ceil($col['red']/$_val);
                        $green_set=ceil($col['green']/$_val) < 0 ? 0 : ceil($col['green']/$_val);
                        $blue_set=ceil($col['blue']/$_val) < 0 ? 0 : ceil($col['blue']/$_val);
                    }
                    else
                    {
                       $_val =50;
                       $red_set=floor($col['red']+$_val) > 255 ? 255 : floor($col['red']+$_val);
                       $green_set=floor($col['green']+$_val) > 255 ? 255 : floor($col['green']+$_val);
                       $blue_set=floor($col['blue']+$_val) > 255 ? 255 : floor($col['blue']+$_val);
                    }
                $col = imagecolorallocate($imgCol02, $red_set, $green_set, $blue_set);
                imagesetpixel($imgCol02, $x, $y, $col);
             }
         }
         switch($imgInfo[2])
         {
                 case 1:
                 case 3:
                    imagepng($imgCol02,$workDir.'/'.$workName.$_SESSION['img']['type']);
                    break;
                 case 2:

                    imagejpeg($imgCol02,$workDir.'/'.$workName.$_SESSION['img']['type'], 100);
                    break;
         }

        imagedestroy($imgCol02);
    }
    else
    {
        for($i=0; $i<imagecolorstotal($imgCol01); $i++)
        {
            $col=ImageColorsForIndex($imgCol01,$i);
            $lgt = 1/(getLightness($col['red'], $col['green'], $col['blue']));
            $_val = 1 + (-0.0061515748 * pow($lgt, 2) + 1.5686515748*$lgt);

            if($_func == 1)
            {
                $red_set=ceil($col['red']*$_val) < 0 ? 0 : ceil($col['red']*$_val);
                $green_set=ceil($col['green']*$_val) < 0 ? 0 : ceil($col['green']*$_val);
                $blue_set=ceil($col['blue']*$_val) < 0 ? 0 : ceil($col['blue']*$_val);
            }
            else
            {
               $red_set=floor($col['red']/$_val) > 255 ? 255 : floor($col['red']/$_val);
               $green_set=floor($col['green']/$_val) > 255 ? 255 : floor($col['green']/$_val);
               $blue_set=floor($col['blue']/$_val) > 255 ? 255 : floor($col['blue']/$_val);
            }
            imagecolorset($imgCol01,$i,$red_set,$green_set,$blue_set);
        }
         switch($imgInfo[2])
         {
                 case 1:
                 case 3:
                    imagepng($imgCol01,$workDir.'/'.$workName.$_SESSION['img']['type']);
                    break;
                 case 2:
                    imagejpeg($imgCol01,$workDir.'/'.$workName.$_SESSION['img']['type'], 100);
                    break;
         }

    }
}
imagedestroy($imgCol01);
?>
